summaryrefslogtreecommitdiff
path: root/tests/rm/unread3
diff options
context:
space:
mode:
Diffstat (limited to 'tests/rm/unread3')
-rwxr-xr-xtests/rm/unread362
1 files changed, 62 insertions, 0 deletions
diff --git a/tests/rm/unread3 b/tests/rm/unread3
new file mode 100755
index 0000000..4021a39
--- /dev/null
+++ b/tests/rm/unread3
@@ -0,0 +1,62 @@
+#!/bin/sh
+# Ensure that rm works even from an unreadable working directory.
+
+# Copyright (C) 2004, 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ rm --version
+fi
+
+PRIV_CHECK_ARG=require-non-root . $srcdir/../priv-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir -p a/1 b c d/2 e/3 || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+cd c
+chmod u=x,go= .
+t=$pwd/$tmp
+
+# With coreutils-5.2.1, this would get a failed assertion.
+rm -r "$t/a" "$t/b" || fail=1
+
+# With coreutils-5.2.1, this would get the following:
+# rm: cannot get current directory: Permission denied
+# rm: failed to return to initial working directory: Bad file descriptor
+rm -r "$t/d" "$t/e" || fail=1
+
+test -d "$t/a" && fail=1
+test -d "$t/b" && fail=1
+test -d "$t/d" && fail=1
+test -d "$t/e" && fail=1
+
+(exit $fail); exit $fail